#pragma GCC optimize("O3")
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <array>
#include <iomanip>
#include <queue>
#include <stack>
#include <numeric>
#include <cassert>
#include <cmath>
#include <random>
#include <ctime>
#include <chrono>

using namespace std;
typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int)x.size())
#define rep(i, a, b) for(int i = a; i < b; ++i)

template <typename T>
void remove_duplicates(vector<T> &v){
    sort(all(v));
    v.resize(unique(all(v)) - v.begin());
}

template <typename T> void chmin(T &a, T b){ a = (b < a) ? b : a; }
template <typename T> void chmax(T &a, T b){ a = (b > a) ? b : a; } 

const int N = 5e5 + 3;
const int LOGN = 20;

int n, a[N];
ll dp[N];

template<class T>
struct RMQ {
	T jmp[LOGN][N];
    RMQ(){}
	RMQ(const vector<T>& V){
        for(int i = 0; i < V.size(); ++i)
            jmp[0][i] = V[i];

		for (int pw = 1, k = 1; pw * 2 <= sz(V); pw *= 2, ++k) {
			// jmp.emplace_back(sz(V) - pw * 2 + 1);
			rep(j,0,sz(V) - pw * 2 + 1)
				jmp[k][j] = min(jmp[k - 1][j], jmp[k - 1][j + pw]);
		}
	}
	T query(int a, int b) {
		assert(a < b); // or return inf if a == b
		int dep = 31 - __builtin_clz(b - a);
		return min(jmp[dep][a], jmp[dep][b - (1 << dep)]);
	}
};
RMQ<int> *f_rmq, *b_rmq;

bool check(int l, int r){
    if(l == r) return true;
    int mid = (l + r) / 2;
    return (f_rmq->query(l, mid + 1) >= -(l - 1)) && (b_rmq->query(mid + 1, r + 1) >= -(n - r));
}

inline ll get_size(ll len){
    ll v = (len + 1) / 2;
    return v * v;
}

int cnt[N], nxt[N];

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    assert(1 <= n && n <= (int)5e5);
    for(int i = 1; i <= n; ++i){
        cin >> a[i];
        assert(1 <= a[i] && a[i] <= (int)1e9);
    }

    vector<int> f{0}, b{0};
    for(int i = 1; i <= n; ++i){
        f.push_back(a[i] - i);
    }
    for(int i = 1; i <= n; ++i){
        b.push_back(a[i] - (n - i + 1));
    }

    f_rmq = new RMQ(f);
    b_rmq = new RMQ(b);

    cnt[n + 1] = 0;

    ll ans = 0;
    for(int i = n; i >= 1; --i){
        cnt[i] = cnt[i + 1] + 1;
        chmin(cnt[i], (int)(n - i) / 2);
        while(!check(i, i + 2 * cnt[i])){
            --cnt[i];
        }

        nxt[i] = 0;
        for(int r = min(cnt[i], nxt[i + 1] + 1); r >= max(0, min(cnt[i], nxt[i + 1] + 1) -1); --r){
            int pos = i + 2 * r;
            ll cand = dp[pos + 1] + get_size(pos - i + 1);
            if(cand > dp[i]){
                dp[i] = cand;
                nxt[i] = r;
            }
        }

        const int C = 3000;
        for(int r = 0; r <= min(C, cnt[i]); ++r){
            int pos = i + 2 * r;
            ll cand = dp[pos + 1] + get_size(pos - i + 1);
            if(cand > dp[i]){
                dp[i] = cand;
                nxt[i] = r;
            }
        }
        int r = cnt[i];
        for(; r >= cnt[i]; --r){
            int pos = i + 2 * r;
            ll cand = dp[pos + 1] + get_size(pos - i + 1);
            if(cand > dp[i]){
                dp[i] = cand;
                nxt[i] = r;
            }
        }
        chmax(ans, dp[i]);
    }
    cout << ans << "\n";
}
